\begin{center}
	\section{Unpacker}
\end{center}

\begin{multicols}{2}
	The unpacker is program written purely in python. Nevertheless this doesn't imply that it's only one script, this code is modular and object oriented. The code is structured in the following manner:
	\linebreak

	\begin{center}
		\includegraphics[scale=0.5]{rsc/unpacker_structure}
	\end{center}

	\subsection{Main}
	The /bin/main.py contains the code that coordinates the scripts under src/unpacker. It's also responsible for parsing the user arguments.
	\linebreak

	Currently the unpacker only supports 2 formats:
	\begin{itemize}
		\item
		CSV(.csv)
		\linebreak
		\quad This will only output the pulse information in a CSV file.
		\item
		ROOT(.root)
		\linebreak
		\quad This will output pulse information along with other metrics.
	\end{itemize}

	The output can be specified to be whatever the user desires, by using the -o option and providing a name with the extension. The extension will be parsed and used to generate the corresponding output, if not recognized, it will default to a root file, whilst using the name provided e.g. -o out.txt will be a root file named "out.txt".

	\subsection{Readers and Parsers}
	Readers are classes that extend the Reader class. Readers implement a function called "process". The process function should return None when no relevant data is available.

	Parser classes don't implement any functions; they only use the constructor to receive a line of text from the DAQ, parse the line and store the data as object properties.

	\begin{minted}
	[
		frame=lines,
		framesep=2mm,
	]
	{python}
class ExampleReader(Reader):
  def __init__(self, ...):
    # INIT CODE

  def process(self, line):
    # PROCESS THE LINE,
    # BUFFER IF NEEDED (CODE)

    if output_ready:
	  # VALID OUTPUT CONSTRUCTED
	  # OR READ, RETURN THE VALUE
	  return ExampleParser(line)
	else
	  # NO VALID DATA AVAILABLE
	  # OR HASN'T BEEN CONSTRUCTED
	  return None

class ExampleParser(object):

  def __init__(self, line):
    # PROCESS LINE
  	# ...
  	# END PROCESS LINE
  	self.a = record['a']
  	self.b = record['b']
	\end{minted}

	\pagebreak
	\subsection{EventReader Module}
	The EventReader class identifies lines coming from the DAQ that match the pattern shown below:

	\begin{lstlisting}[breaklines=true, frame=single]
^.*([0-9A-F]{8}(?:\s[0-9A-F]{2}){8}\s[0-9A-F]{8}\s\d+\.\d+\s\d+\s[AV]\s[0-9]{2}\s\d\s[+-]\d+).*$
	\end{lstlisting}

	The pattern above is only valid for lines that contain information regarding pulse edges. In which case, the EventReader will scan the line and check if there was a trigger signal. A trigger signal indicates that a coincidence was found, meaning that a muon passed through $n$ number of scintillators (This depends on the coincidence fold set by the user at the beginning of the run) in a given window of time. Once it identifies the start of the event it starts buffering the edges until it finds the next trigger signal, when it does, the edges are sorted by time and returned, and it starts buffering the new event, as depicted in the image below.

	\includegraphics[scale=0.5]{rsc/event_reader}
	\captionof{figure}{Example of event reconstruction. The arrows represent an event. An event is a group of lines from the DAQ that arrive in between two trigger signals. Each vertical line that divides the arrow container represents a line received. The trigger signal arrives at the first and last partition. When an arrow is closed, that arrow is returned.}

	The Entry class parses the binary values and makes them available to the EventReader in a friendlier way, in other words, it takes the line of text, and parses it; placing each value in a well named variable. These variables correspond to the words defined in the quarknet DAQ manual \cite{quarknet}.
	It's important to mention that due to the limitations of the 64 bit float (double but in python 3 called float) it's not possible to store seconds plus all the nanoseconds in one variable. To workaround this, date (unixtime in seconds), time (seconds) and nanos (nanoseconds) are stored in different variables.

	The Edge class represents a pulse edge. Once the EventReader reads an entry, it identifies all the edges and creates instances of the Edge class for each of them.

	\subsection{ScalersReader Module}

	This module contains various classes: ScalersReader, Status, Scalers and Period.

	The Status class is a Parser; it's in charge of parsing records that match the pattern below:

	\begin{lstlisting}[breaklines=true, frame=single]
^.*(ST\s\d+\s[+-]\d+\s[+-]\d+\s\d+\s\d+\s\d+\s[AV]\s\d+\s[0-9A-F]{8}\s\d+\s\d+\s[0-9A-F]{8}\s[0-9A-F]{8}).*$
	\end{lstlisting}

	These lines of text contain information regarding the current state of the DAQ, however we only care about the timestamp value.

	Scalers are hit counts reported by the DAQ. The scalers line (pattern shown below) reports 5 values: coincidence count, ch0 (channel 0) count, ch1 count, ch2 count and ch3 count. The 4 channel counts don't measure coincidences, rather they count individual hits on each of them independently if they occurred at the same time or not.

	\begin{lstlisting}[breaklines=true, frame=single]
^.*(DS(?:\s[0-9A-F]{8}){5}).*$
	\end{lstlisting}

	The ScalersReader opens a Period when a status line appears, then sums all hit counts per channel until the next status line shows up, in doing so, the rate is calculated per channel.

	\subsection{Channel Module}
	This module contains the Channel class used to represent a physical channel. The channel takes the outputs returned by the EventReader and the ScalersReader, so long as they are non null values (if null this means the readers didn't find any useful data). There are two important functions in the Channel class, namely, read\_rate and read\_pulse, they each take one argument, a Period and an Event, respectively.

	Pulses are reconstructed easily by pairing rising edges with falling edges for each channel. However there are cases in which a rising edge may be orphan due to the pulse starting late in the event and ending beyond the trigger window, hence the falling edge is not recorded. When we pair rising edges and falling edges it's trivial to assign a duration, however for the orphans we use -1 which means: "closes beyond the event".

	Rate measurements are trivially obtained by taking the total hit counts within a period and dividing them by the period's duration.

\end{multicols}
